<!DOCTYPE html>
<html>
<head>
    <style> 
        body { margin: 0; }
        #globeViz { width: 100vw; height: 100vh; }
    </style>

    <script src="https://unpkg.com/three"></script>
    <script src="https://unpkg.com/topojson-client@3"></script>
    <script src="https://unpkg.com/globe.gl"></script>
</head>

<body>
    <div id="globeViz"></div>

    <script>
      const world = Globe()(document.getElementById('globeViz'))
        .backgroundColor('rgba(255, 255, 255, 1)')
        .showGlobe(true)
        .showAtmosphere(false);

      fetch('https://unpkg.com/world-atlas/land-110m.json').then(res => res.json())
        .then(landTopo => {
          world
            .polygonsData(topojson.feature(landTopo, landTopo.objects.land).features)
            .polygonCapMaterial(new THREE.MeshLambertMaterial({ color: 'rgba(139, 149, 246, 1)', side: THREE.DoubleSide }))
            .polygonSideColor(() => 'rgba(255, 255, 255, 1)');

          // Call an external API for data
          fetch('https://api.yourdata.com/data')
            .then(response => response.json())
            .then(data => {
              // Assuming the API returns an array of objects with lat, lng, and size properties
              const gData = data.map(d => ({
                lat: d.lat,
                lng: d.lng,
                size: d.size,
                color: ['red', 'white', 'blue', 'green'][Math.round(Math.random() * 3)] // Random color for demo purposes
              }));

              // Add spikes to the globe
              world.pointsData(gData)
                .pointAltitude('size')
                .pointColor('color');
            })
            .catch(error => console.error('Error fetching data:', error));

          const globeMaterial = world.globeMaterial();
          globeMaterial.specular = new THREE.Color('grey');
          globeMaterial.color.set(0xA2A9F8);
          globeMaterial.flatshading = false;

          //Add Auto-Rotation
          world.controls().autoRotate = true;
          world.controls().autoRotateSpeed = 0.6; 
        });
    </script>
</body>
</html>
